/* A Bison parser, made by GNU Bison 2.1.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0

/* Substitute the variable and function names.  */
#define yyparse ppparse
#define yylex   pplex
#define yyerror pperror
#define yylval  pplval
#define yychar  ppchar
#define yydebug ppdebug
#define yynerrs ppnerrs


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     TOKEN_EOF = 0,
     BY = 258,
     COPY = 259,
     EQEQ = 260,
     IN = 261,
     LEADING = 262,
     OF = 263,
     OFF = 264,
     PRINTING = 265,
     REPLACE = 266,
     REPLACING = 267,
     SUPPRESS = 268,
     TRAILING = 269,
     DOT = 270,
     SOURCE_DIRECTIVE = 271,
     FORMAT = 272,
     IS = 273,
     FIXED = 274,
     FREE = 275,
     DEFINE_DIRECTIVE = 276,
     AS = 277,
     PARAMETER = 278,
     OVERRIDE = 279,
     SET_DIRECTIVE = 280,
     CONSTANT = 281,
     SOURCEFORMAT = 282,
     FOLDCOPYNAME = 283,
     NOFOLDCOPYNAME = 284,
     IF_DIRECTIVE = 285,
     ELSE_DIRECTIVE = 286,
     ENDIF_DIRECTIVE = 287,
     ELIF_DIRECTIVE = 288,
     GE = 289,
     LE = 290,
     LT = 291,
     GT = 292,
     EQ = 293,
     NE = 294,
     NOT = 295,
     THAN = 296,
     TO = 297,
     OR = 298,
     EQUAL = 299,
     GREATER = 300,
     LESS = 301,
     SET = 302,
     DEFINED = 303,
     TERMINATOR = 304,
     TOKEN = 305,
     VARIABLE = 306,
     LITERAL = 307
   };
#endif
/* Tokens.  */
#define TOKEN_EOF 0
#define BY 258
#define COPY 259
#define EQEQ 260
#define IN 261
#define LEADING 262
#define OF 263
#define OFF 264
#define PRINTING 265
#define REPLACE 266
#define REPLACING 267
#define SUPPRESS 268
#define TRAILING 269
#define DOT 270
#define SOURCE_DIRECTIVE 271
#define FORMAT 272
#define IS 273
#define FIXED 274
#define FREE 275
#define DEFINE_DIRECTIVE 276
#define AS 277
#define PARAMETER 278
#define OVERRIDE 279
#define SET_DIRECTIVE 280
#define CONSTANT 281
#define SOURCEFORMAT 282
#define FOLDCOPYNAME 283
#define NOFOLDCOPYNAME 284
#define IF_DIRECTIVE 285
#define ELSE_DIRECTIVE 286
#define ENDIF_DIRECTIVE 287
#define ELIF_DIRECTIVE 288
#define GE 289
#define LE 290
#define LT 291
#define GT 292
#define EQ 293
#define NE 294
#define NOT 295
#define THAN 296
#define TO 297
#define OR 298
#define EQUAL 299
#define GREATER 300
#define LESS 301
#define SET 302
#define DEFINED 303
#define TERMINATOR 304
#define TOKEN 305
#define VARIABLE 306
#define LITERAL 307




/* Copy the first part of user declarations.  */
#line 29 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"

#include "config.h"

#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "cobc.h"

#define pperror ppparse_error

#define COND_EQ		0
#define COND_LT		1U
#define COND_GT		2U
#define COND_LE		3U
#define COND_GE		4U
#define COND_NE		5U

/* Local variables */

static unsigned int	current_cmd;

#if	0	/* RXWRXW OPT */
static const char	* const compopts[] = {
	"ibm",
	"ibmcomp",
	"iso2002",
	"mf",
	"mfcomment",
	"sticky-linkage",
	"trunc",
	"noibmcomp",
	"nofold-copy-name",
	"nofoldcopyname",
	"nomfcomment",
	"nosticky-linkage",
	"notrunc"
};

static const char	* const varopts[] = {
	"fold-copy-name",
	"foldcopyname",
	"sourceformat",
	"trunc"
};
#endif

/* Local functions */

static char *
fix_filename (char *name)
{
	/* remove quotation from alphanumeric literals */
	if (name[0] == '\'' || name[0] == '\"') {
		name++;
		name[strlen (name) - 1] = 0;
	}
	return name;
}

static char *
fold_lower (char *name)
{
	unsigned char	*p;

	for (p = (unsigned char *)name; *p; p++) {
		if (isupper (*p)) {
			*p = tolower (*p);
		}
	}
	return name;
}

static char *
fold_upper (char *name)
{
	unsigned char	*p;

	for (p = (unsigned char *)name; *p; p++) {
		if (islower (*p)) {
			*p = toupper (*p);
		}
	}
	return name;
}

static struct cb_replace_list *
cb_replace_list_add (struct cb_replace_list *list,
		     struct cb_text_list *old_text,
		     struct cb_text_list *new_text,
		     size_t lead_or_trail)
{
	struct cb_replace_list *p;
	struct cb_replace_list *l;

	p = cobc_malloc (sizeof (struct cb_replace_list));
	p->next = NULL;
	p->old_text = old_text;
	p->new_text = new_text;
	p->leading_trailing = lead_or_trail;
	if (!list) {
		return p;
	} else {
		for (l = list; l->next; l = l->next) {
			;
		}
		l->next = p;
		return list;
	}
}

static unsigned int
cb_compare_vals (struct cb_define_struct *p1, struct cb_define_struct *p2,
		 unsigned int cond)
{
	int	result;

	if (!p1 || !p2) {
		return 0;
	}
	if (p1->deftype != PLEX_DEF_LIT && p1->deftype != PLEX_DEF_NUM) {
		return 0;
	}
	if (p2->deftype != PLEX_DEF_LIT && p2->deftype != PLEX_DEF_NUM) {
		return 0;
	}
	if (p1->deftype != p2->deftype) {
		ppparse_error (_("Invalid directive comparison"));
		return 0;
	}
	if (p1->deftype == PLEX_DEF_LIT) {
		result = strcmp (p1->value, p2->value);
	} else {
		if (p1->sign && !p2->sign) {
			result = -1;
		} else if (!p1->sign && p2->sign) {
			result = 1;
		} else if (p1->int_part < p2->int_part) {
			if (p1->sign) {
				result = 1;
			} else {
				result = -1;
			}
		} else if (p1->int_part > p2->int_part) {
			if (p1->sign) {
				result = -1;
			} else {
				result = 1;
			}
		} else if (p1->dec_part < p2->dec_part) {
			if (p1->sign) {
				result = 1;
			} else {
				result = -1;
			}
		} else if (p1->dec_part > p2->dec_part) {
			if (p1->sign) {
				result = -1;
			} else {
				result = 1;
			}
		} else {
			result = 0;
		}
	}
	switch (cond) {
	case COND_EQ:
		return (result == 0);
		break;
	case COND_LT:
		return (result < 0);
		break;
	case COND_GT:
		return (result > 0);
		break;
	case COND_LE:
		return (result <= 0);
		break;
	case COND_GE:
		return (result >= 0);
		break;
	case COND_NE:
		return (result != 0);
		break;
	default:
		break;
	}
	return 0;
}

static struct cb_define_struct *
cb_define_add (struct cb_define_struct *list, const char *name,
	       const char *text, const unsigned int override)
{
	struct cb_define_struct	*p;
	struct cb_define_struct	*l;

	/* Check duplicate */
	for (l = list; l; l = l->next) {
		if (!strcasecmp (name, l->name)) {
			if (!override && l->deftype != PLEX_DEF_DEL) {
				ppparse_error (_("Duplicate define"));
				return NULL;
			}
			if (l->value) {
				free (l->value);
				l->value = NULL;
			}
			if (cb_set_value (l, text)) {
				ppparse_error (_("Invalid constant"));
				return NULL;
			}
			return list;
		}
	}

	p = cobc_malloc (sizeof (struct cb_define_struct));
	p->next = NULL;
	p->name = cobc_strdup (name);
	if (cb_set_value (p, text)) {
		ppparse_error (_("Invalid constant"));
		free (p->name);
		free (p);
		return NULL;
	}

	if (!list) {
		return p;
	}
	for (l = list; l->next; l = l->next) {
		;
	}
	l->next = p;
	return list;
}

static void
cb_define_del (const char *name)
{
	struct cb_define_struct	*l;

	for (l = cb_setvar_list; l; l = l->next) {
		if (!strcmp (name, l->name)) {
			l->deftype = PLEX_DEF_DEL;
			if (l->value) {
				free (l->value);
				l->value = NULL;
			}
			l->sign = 0;
			l->int_part = 0;
			l->dec_part = 0;
			break;
		}
	}
}

static struct cb_define_struct *
cb_search_lists (const char *name)
{
	struct cb_define_struct	*p;

	for (p = cb_define_list; p; p = p->next) {
		if (!strcasecmp (name, p->name)) {
			return p;
			break;
		}
	}
	for (p = cb_setvar_list; p; p = p->next) {
		if (!strcasecmp (name, p->name)) {
			if (p->deftype != PLEX_DEF_DEL) {
				return p;
			}
			break;
		}
	}
	return NULL;
}

static unsigned int
ppp_search_comp_vars (const char *name)
{
#undef	CB_PARSE_DEF
#define	CB_PARSE_DEF(x,z)	if (!strcasecmp (name, x)) return (z);
#include "ppparse.def"
#undef	CB_PARSE_DEF
	return 0;
}



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 1
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 321 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
typedef union YYSTYPE {
	char			*s;
	struct cb_text_list	*l;
	struct cb_replace_list	*r;
	struct cb_define_struct	*ds;
	unsigned int		ui;
	int			si;
} YYSTYPE;
/* Line 196 of yacc.c.  */
#line 500 "ppparse.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 219 of yacc.c.  */
#line 512 "ppparse.c"

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && (defined (size_t) || defined(_MSC_VER))
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T) && (defined (__STDC__) || defined (__cplusplus))
# include <stddef.h> /* INFRINGES ON USER NAME SPACE */
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if defined (__STDC__) || defined (__cplusplus)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     define YYINCLUDED_STDLIB_H
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2005 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM ((YYSIZE_T) -1)
#  endif
#  ifdef __cplusplus
extern "C" {
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if (! defined (malloc) && ! defined (YYINCLUDED_STDLIB_H) \
	&& (defined (__STDC__) || defined (__cplusplus)))
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if (! defined (free) && ! defined (YYINCLUDED_STDLIB_H) \
	&& (defined (__STDC__) || defined (__cplusplus)))
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifdef __cplusplus
}
#  endif
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short int yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short int) + sizeof (YYSTYPE))			\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined (__GNUC__) && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short int yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   149

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  55
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  36
/* YYNRULES -- Number of rules. */
#define YYNRULES  96
/* YYNRULES -- Number of states. */
#define YYNSTATES  164

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   307

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      53,    54,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short int yyprhs[] =
{
       0,     0,     3,     4,     7,    10,    13,    16,    19,    22,
      25,    26,    30,    31,    35,    37,    39,    41,    44,    49,
      52,    56,    58,    62,    63,    66,    70,    72,    74,    78,
      83,    88,    94,    99,   104,   110,   116,   118,   120,   126,
     129,   135,   138,   141,   143,   145,   147,   149,   151,   153,
     159,   160,   163,   166,   167,   170,   171,   174,   177,   180,
     184,   189,   194,   199,   205,   211,   215,   217,   220,   224,
     226,   230,   233,   237,   239,   242,   244,   248,   252,   257,
     259,   262,   263,   265,   266,   268,   269,   271,   272,   274,
     275,   277,   278,   280,   281,   283,   284
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      56,     0,    -1,    -1,    56,    57,    -1,    70,    15,    -1,
      74,    15,    -1,    58,    49,    -1,    16,    64,    -1,    21,
      66,    -1,    25,    61,    -1,    -1,    30,    59,    67,    -1,
      -1,    33,    60,    67,    -1,    31,    -1,    32,    -1,    62,
      -1,    61,    62,    -1,    26,    51,    85,    52,    -1,    51,
      63,    -1,    27,    85,    52,    -1,    29,    -1,    28,    85,
      52,    -1,    -1,    85,    52,    -1,    86,    87,    65,    -1,
      19,    -1,    20,    -1,    51,    85,     9,    -1,    51,    85,
      23,    83,    -1,    51,    85,    52,    83,    -1,    26,    51,
      85,    52,    83,    -1,    51,    87,    84,    48,    -1,    51,
      87,    84,    47,    -1,    51,    87,    84,    69,    68,    -1,
      52,    87,    84,    69,    68,    -1,    52,    -1,    51,    -1,
      45,    89,    43,    44,    90,    -1,    45,    89,    -1,    46,
      89,    43,    44,    90,    -1,    46,    89,    -1,    44,    90,
      -1,    34,    -1,    37,    -1,    35,    -1,    36,    -1,    38,
      -1,    39,    -1,     4,    50,    71,    72,    73,    -1,    -1,
       6,    50,    -1,     8,    50,    -1,    -1,    13,    88,    -1,
      -1,    12,    75,    -1,    11,    75,    -1,    11,     9,    -1,
      76,     3,    77,    -1,     7,    78,     3,    79,    -1,    14,
      78,     3,    79,    -1,    75,    76,     3,    77,    -1,    75,
       7,    78,     3,    79,    -1,    75,    14,    78,     3,    79,
      -1,     5,    80,     5,    -1,    81,    -1,     5,     5,    -1,
       5,    80,     5,    -1,    81,    -1,     5,    50,     5,    -1,
       5,     5,    -1,     5,    50,     5,    -1,    50,    -1,    80,
      50,    -1,    50,    -1,    81,     6,    50,    -1,    81,     8,
      50,    -1,    81,    53,    82,    54,    -1,    50,    -1,    82,
      50,    -1,    -1,    24,    -1,    -1,    40,    -1,    -1,    22,
      -1,    -1,    17,    -1,    -1,    18,    -1,    -1,    10,    -1,
      -1,    41,    -1,    -1,    42,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short int yyrline[] =
{
       0,   408,   408,   409,   413,   414,   415,   419,   420,   421,
     423,   422,   428,   427,   432,   436,   443,   444,   448,   458,
     459,   480,   485,   512,   515,   522,   526,   530,   537,   541,
     554,   563,   577,   584,   591,   601,   620,   634,   648,   652,
     656,   660,   664,   668,   672,   676,   680,   684,   688,   695,
     718,   721,   725,   731,   732,   737,   740,   747,   751,   758,
     762,   766,   770,   774,   778,   785,   789,   796,   800,   804,
     811,   818,   822,   829,   833,   840,   844,   851,   858,   873,
     877,   888,   891,   899,   902,   908,   908,   909,   909,   910,
     910,   911,   911,   912,   912,   913,   913
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "$undefined", "BY", "COPY", "\"==\"", "IN",
  "LEADING", "OF", "OFF", "PRINTING", "REPLACE", "REPLACING", "SUPPRESS",
  "TRAILING", "\".\"", "SOURCE_DIRECTIVE", "FORMAT", "IS", "FIXED", "FREE",
  "DEFINE_DIRECTIVE", "AS", "PARAMETER", "OVERRIDE", "SET_DIRECTIVE",
  "CONSTANT", "SOURCEFORMAT", "FOLDCOPYNAME", "NOFOLDCOPYNAME",
  "IF_DIRECTIVE", "ELSE_DIRECTIVE", "ENDIF_DIRECTIVE", "ELIF_DIRECTIVE",
  "\">=\"", "\"<=\"", "\"<\"", "\">\"", "\"=\"", "\"<>\"", "NOT", "THAN",
  "TO", "OR", "EQUAL", "GREATER", "LESS", "SET", "DEFINED",
  "\"end of line\"", "\"Identifier or Literal\"", "\"Variable\"",
  "\"Literal\"", "'('", "')'", "$accept", "statement_list", "statement",
  "directive", "@1", "@2", "set_directive", "set_choice", "set_options",
  "source_directive", "format_type", "define_directive", "if_directive",
  "object_id", "condition_clause", "copy_statement", "copy_in",
  "copy_suppress", "copy_replacing", "replace_statement", "replacing_list",
  "text_src", "text_dst", "text_partial_src", "text_partial_dst",
  "token_list", "identifier", "subscripts", "_override", "_not", "_as",
  "_format", "_is", "_printing", "_than", "_to", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short int yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,    40,    41
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    55,    56,    56,    57,    57,    57,    58,    58,    58,
      59,    58,    60,    58,    58,    58,    61,    61,    62,    62,
      62,    62,    62,    63,    63,    64,    65,    65,    66,    66,
      66,    66,    67,    67,    67,    67,    68,    68,    69,    69,
      69,    69,    69,    69,    69,    69,    69,    69,    69,    70,
      71,    71,    71,    72,    72,    73,    73,    74,    74,    75,
      75,    75,    75,    75,    75,    76,    76,    77,    77,    77,
      78,    79,    79,    80,    80,    81,    81,    81,    81,    82,
      82,    83,    83,    84,    84,    85,    85,    86,    86,    87,
      87,    88,    88,    89,    89,    90,    90
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     0,     2,     2,     2,     2,     2,     2,     2,
       0,     3,     0,     3,     1,     1,     1,     2,     4,     2,
       3,     1,     3,     0,     2,     3,     1,     1,     3,     4,
       4,     5,     4,     4,     5,     5,     1,     1,     5,     2,
       5,     2,     2,     1,     1,     1,     1,     1,     1,     5,
       0,     2,     2,     0,     2,     0,     2,     2,     2,     3,
       4,     4,     4,     5,     5,     3,     1,     2,     3,     1,
       3,     2,     3,     1,     2,     1,     3,     3,     4,     1,
       2,     0,     1,     0,     1,     0,     1,     0,     1,     0,
       1,     0,     1,     0,     1,     0,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       2,     0,     1,     0,     0,    87,     0,     0,    10,    14,
      15,    12,     3,     0,     0,     0,    50,     0,     0,    58,
       0,    75,    57,     0,    66,    88,     7,    89,     0,    85,
       8,     0,    85,    85,    21,    23,     9,    16,     0,     0,
       6,     4,     5,     0,     0,    53,    73,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    90,     0,
      85,    86,     0,    85,     0,     0,    19,     0,    17,    89,
      89,    11,    13,    51,    52,    91,    55,    65,    74,     0,
       0,     0,     0,     0,     0,     0,    59,    69,    76,    77,
      79,     0,    26,    27,    25,     0,    28,    81,    81,     0,
      20,    22,    24,    83,    83,    92,    54,     0,    49,    70,
       0,    60,    61,     0,     0,    62,    67,     0,    80,    78,
      81,    82,    29,    30,    18,    84,     0,     0,    56,    71,
       0,    63,    64,    68,    31,    43,    45,    46,    44,    47,
      48,    95,    93,    93,    33,    32,     0,     0,    72,    96,
      42,    94,    39,    41,    37,    36,    34,    35,     0,     0,
      95,    95,    38,    40
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short int yydefgoto[] =
{
      -1,     1,    12,    13,    38,    39,    36,    37,    66,    26,
      94,    30,    71,   156,   146,    14,    45,    76,   108,    15,
      22,    23,    86,    49,   111,    47,    24,    91,   122,   126,
      62,    27,    59,   106,   152,   150
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -84
static const short int yypact[] =
{
     -84,    51,   -84,   -20,    -3,    15,    -8,    59,   -84,   -84,
     -84,   -84,   -84,   -15,    21,    26,    19,     2,    41,   -84,
      41,   -84,     0,    60,    -5,   -84,   -84,    53,    24,    57,
     -84,    29,    57,    57,   -84,    18,    59,   -84,   -13,   -13,
     -84,   -84,   -84,    45,    46,    84,   -84,     4,    48,   101,
     102,    41,    41,   104,     7,    58,    67,    68,   -84,    25,
      57,   -84,    12,    57,    72,    73,   -84,    74,   -84,    53,
      53,   -84,   -84,   -84,   -84,    99,   107,   -84,   -84,   115,
     122,   122,   125,   126,     7,     8,   -84,    -5,   -84,   -84,
     -84,   -28,   -84,   -84,   -84,    78,   -84,   108,   108,    79,
     -84,   -84,   -84,    93,    93,   -84,   -84,     3,   -84,   -84,
      10,   -84,   -84,   122,   122,   -84,   -84,    11,   -84,   -84,
     108,   -84,   -84,   -84,   -84,   -84,    55,    77,     0,   -84,
     129,   -84,   -84,   -84,   -84,   -84,   -84,   -84,   -84,   -84,
     -84,    94,    96,    96,   -84,   -84,    22,    22,   -84,   -84,
     -84,   -84,    92,    95,   -84,   -84,   -84,   -84,    97,    98,
      94,    94,   -84,   -84
};

/* YYPGOTO[NTERM-NUM].  */
static const yysigned_char yypgoto[] =
{
     -84,   -84,   -84,   -84,   -84,   -84,   -84,   103,   -84,   -84,
     -84,   -84,   105,    -7,    16,   -84,   -84,   -84,   -84,   -84,
      38,   -22,    62,    17,   -48,    63,   -35,   -84,   -78,    43,
      -4,   -84,   -46,   -84,     6,   -83
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -86
static const short int yytable[] =
{
      53,    55,    17,    56,    18,    17,    19,    51,    17,    77,
      18,    20,    85,   116,    52,   129,   133,    20,    28,    87,
     123,    96,   118,   103,   104,    43,   119,    44,    64,    65,
      16,    67,    25,   112,    40,    97,    41,    50,    69,    70,
      61,    42,   134,    29,    92,    93,    48,    21,    57,    87,
      21,     2,    46,    21,    78,     3,    95,    21,    46,    99,
     130,    78,     4,    54,    98,   131,   132,     5,    82,    83,
     -85,    58,     6,   154,   155,    60,     7,   162,   163,    61,
      63,     8,     9,    10,    11,    31,    32,    33,    34,   135,
     136,   137,   138,   139,   140,    73,    74,    75,    79,   141,
     142,   143,   144,   145,    80,    81,    53,    84,    88,   105,
      35,   135,   136,   137,   138,   139,   140,    89,    90,   107,
     109,   141,   142,   143,   100,   101,   102,   110,   113,   114,
     120,   124,   121,   125,   148,   158,   149,   151,   159,    68,
     157,   160,   161,   147,    72,   128,   115,   127,   117,   153
};

static const unsigned char yycheck[] =
{
      22,     6,     5,     8,     7,     5,     9,     7,     5,     5,
       7,    14,     5,     5,    14,     5,     5,    14,    26,    54,
      98,     9,    50,    69,    70,     6,    54,     8,    32,    33,
      50,    35,    17,    81,    49,    23,    15,    20,    51,    52,
      22,    15,   120,    51,    19,    20,     5,    50,    53,    84,
      50,     0,    50,    50,    50,     4,    60,    50,    50,    63,
      50,    50,    11,     3,    52,   113,   114,    16,    51,    52,
      52,    18,    21,    51,    52,    51,    25,   160,   161,    22,
      51,    30,    31,    32,    33,    26,    27,    28,    29,    34,
      35,    36,    37,    38,    39,    50,    50,    13,    50,    44,
      45,    46,    47,    48,     3,     3,   128,     3,    50,    10,
      51,    34,    35,    36,    37,    38,    39,    50,    50,    12,
       5,    44,    45,    46,    52,    52,    52,     5,     3,     3,
      52,    52,    24,    40,     5,    43,    42,    41,    43,    36,
     147,    44,    44,   127,    39,   107,    84,   104,    85,   143
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,    56,     0,     4,    11,    16,    21,    25,    30,    31,
      32,    33,    57,    58,    70,    74,    50,     5,     7,     9,
      14,    50,    75,    76,    81,    17,    64,    86,    26,    51,
      66,    26,    27,    28,    29,    51,    61,    62,    59,    60,
      49,    15,    15,     6,     8,    71,    50,    80,     5,    78,
      78,     7,    14,    76,     3,     6,     8,    53,    18,    87,
      51,    22,    85,    51,    85,    85,    63,    85,    62,    51,
      52,    67,    67,    50,    50,    13,    72,     5,    50,    50,
       3,     3,    78,    78,     3,     5,    77,    81,    50,    50,
      50,    82,    19,    20,    65,    85,     9,    23,    52,    85,
      52,    52,    52,    87,    87,    10,    88,    12,    73,     5,
       5,    79,    79,     3,     3,    77,     5,    80,    50,    54,
      52,    24,    83,    83,    52,    40,    84,    84,    75,     5,
      50,    79,    79,     5,    83,    34,    35,    36,    37,    38,
      39,    44,    45,    46,    47,    48,    69,    69,     5,    42,
      90,    41,    89,    89,    51,    52,    68,    68,    43,    43,
      44,    44,    90,    90
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (0)


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (N)								\
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (0)
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
              (Loc).first_line, (Loc).first_column,	\
              (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr,					\
                  Type, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short int *bottom, short int *top)
#else
static void
yy_stack_print (bottom, top)
    short int *bottom;
    short int *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu), ",
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname[yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      size_t yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

#endif /* YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);


# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The look-ahead symbol.  */
int yychar;

/* The semantic value of the look-ahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
int yyparse()

#endif
{
  
  int yystate;
  int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short int yyssa[YYINITDEPTH];
  short int *yyss = yyssa;
  short int *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short int *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short int *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a look-ahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to look-ahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 10:
#line 423 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	current_cmd = PLEX_ACT_IF;
  ;}
    break;

  case 12:
#line 428 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	current_cmd = PLEX_ACT_ELIF;
  ;}
    break;

  case 14:
#line 433 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	plex_action_directive (PLEX_ACT_ELSE, 0);
  ;}
    break;

  case 15:
#line 437 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	plex_action_directive (PLEX_ACT_END, 0);
  ;}
    break;

  case 18:
#line 449 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	struct cb_define_struct	*p;

	p = cb_define_add (cb_setvar_list, (yyvsp[-2].s), (yyvsp[0].s), 1);
	if (p) {
		cb_setvar_list = p;
	}
	fprintf (ppout, "#deflit %s %s\n", (yyvsp[-2].s), (yyvsp[0].s));
  ;}
    break;

  case 20:
#line 460 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	char	*p;
	size_t	size;
	int	quote;

	p = (yyvsp[0].s);
	if (*p == '\"' || *p == '\'') {
		quote = *p;
		p++;
		size = strlen (p) - 1;
		p[size] = 0;
	}
	if (!strcasecmp (p, "FIXED")) {
		cb_source_format = CB_FORMAT_FIXED;
	} else if (!strcasecmp (p, "FREE")) {
		cb_source_format = CB_FORMAT_FREE;
	} else {
		ppparse_error (_("Invalid SOURCEFORMAT directive"));
	}
  ;}
    break;

  case 21:
#line 481 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	cb_flag_fold_copy_upper = 0;
	cb_flag_fold_copy_lower = 0;
  ;}
    break;

  case 22:
#line 486 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	char	*p;
	size_t	size;
	int	quote;

	p = (yyvsp[0].s);
	if (*p == '\"' || *p == '\'') {
		quote = *p;
		p++;
		size = strlen (p) - 1;
		p[size] = 0;
	}
	if (!strcasecmp (p, "UPPER")) {
		cb_flag_fold_copy_upper = 1;
		cb_flag_fold_copy_lower = 0;
	} else if (!strcasecmp (p, "LOWER")) {
		cb_flag_fold_copy_upper = 0;
		cb_flag_fold_copy_lower = 1;
	} else {
		ppparse_error (_("Invalid FOLD-COPY-NAME directive"));
	}
  ;}
    break;

  case 23:
#line 512 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	fprintf (ppout, "#option %s\n", (yyvsp[0].s));
  ;}
    break;

  case 24:
#line 516 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	fprintf (ppout, "#option %s %s\n", (yyvsp[-2].s), (yyvsp[0].s));
  ;}
    break;

  case 26:
#line 527 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	cb_source_format = CB_FORMAT_FIXED;
  ;}
    break;

  case 27:
#line 531 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	cb_source_format = CB_FORMAT_FREE;
  ;}
    break;

  case 28:
#line 538 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	cb_define_del ((yyvsp[-2].s));
  ;}
    break;

  case 29:
#line 542 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	char			*s;
	struct cb_define_struct	*p;

	s = getenv ((yyvsp[-3].s));
	if (s && *s && *s != ' ') {
		p = cb_define_add (cb_setvar_list, (yyvsp[-3].s), s, (yyvsp[0].ui));
		if (p) {
			cb_setvar_list = p;
		}
	}
  ;}
    break;

  case 30:
#line 555 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	struct cb_define_struct	*p;

	p = cb_define_add (cb_setvar_list, (yyvsp[-3].s), (yyvsp[-1].s), (yyvsp[0].ui));
	if (p) {
		cb_setvar_list = p;
	}
  ;}
    break;

  case 31:
#line 564 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	struct cb_define_struct	*p;

	p = cb_define_add (cb_setvar_list, (yyvsp[-3].s), (yyvsp[-1].s), (yyvsp[0].ui));
	if (p) {
		cb_setvar_list = p;
	}
	fprintf (ppout, "#deflit %s %s\n", (yyvsp[-3].s), (yyvsp[-1].s));
  ;}
    break;

  case 32:
#line 578 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	unsigned int		found;

	found = (cb_search_lists ((yyvsp[-3].s)) != NULL);
	plex_action_directive (current_cmd, found ^ (yyvsp[-1].ui));
  ;}
    break;

  case 33:
#line 585 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	unsigned int		found;

	found = ppp_search_comp_vars ((yyvsp[-3].s));
	plex_action_directive (current_cmd, found ^ (yyvsp[-1].ui));
  ;}
    break;

  case 34:
#line 592 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	struct cb_define_struct	*p;
	unsigned int		found;

	found = 0;
	p = cb_search_lists ((yyvsp[-4].s));
	found = cb_compare_vals (p, (yyvsp[0].ds), (yyvsp[-1].ui));
	plex_action_directive (current_cmd, found ^ (yyvsp[-2].ui));
  ;}
    break;

  case 35:
#line 602 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	struct cb_define_struct	*p;
	unsigned int		found;

	found = 0;
	p = cobc_malloc (sizeof (struct cb_define_struct));
	p->next = NULL;
	if (cb_set_value (p, (yyvsp[-4].s))) {
		ppparse_error (_("Invalid constant"));
		free (p);
	} else {
		found = cb_compare_vals (p, (yyvsp[0].ds), (yyvsp[-1].ui));
	}
	plex_action_directive (current_cmd, found ^ (yyvsp[-2].ui));
  ;}
    break;

  case 36:
#line 621 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	struct cb_define_struct	*p;

	p = cobc_malloc (sizeof (struct cb_define_struct));
	p->next = NULL;
	if (cb_set_value (p, (yyvsp[0].s))) {
		ppparse_error (_("Invalid constant"));
		free (p);
		(yyval.ds) = NULL;
	} else {
		(yyval.ds) = p;
	}
  ;}
    break;

  case 37:
#line 635 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	struct cb_define_struct	*p;

	p = cb_search_lists ((yyvsp[0].s));
	if (p != NULL && p->deftype != PLEX_DEF_NONE) {
		(yyval.ds) = p;
	} else {
		(yyval.ds) = NULL;
	}
  ;}
    break;

  case 38:
#line 649 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	(yyval.ui) = COND_GE;
  ;}
    break;

  case 39:
#line 653 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	(yyval.ui) = COND_GT;
  ;}
    break;

  case 40:
#line 657 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	(yyval.ui) = COND_LE;
  ;}
    break;

  case 41:
#line 661 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	(yyval.ui) = COND_LT;
  ;}
    break;

  case 42:
#line 665 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	(yyval.ui) = COND_EQ;
  ;}
    break;

  case 43:
#line 669 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	(yyval.ui) = COND_GE;
  ;}
    break;

  case 44:
#line 673 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	(yyval.ui) = COND_GT;
  ;}
    break;

  case 45:
#line 677 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	(yyval.ui) = COND_LE;
  ;}
    break;

  case 46:
#line 681 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	(yyval.ui) = COND_LT;
  ;}
    break;

  case 47:
#line 685 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	(yyval.ui) = COND_EQ;
  ;}
    break;

  case 48:
#line 689 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	(yyval.ui) = COND_NE;
  ;}
    break;

  case 49:
#line 696 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	fputc ('\n', ppout);
	(yyvsp[-3].s) = fix_filename ((yyvsp[-3].s));
	if (cb_flag_fold_copy_lower) {
		(yyvsp[-3].s) = fold_lower ((yyvsp[-3].s));
	} else if (cb_flag_fold_copy_upper) {
		(yyvsp[-3].s) = fold_upper ((yyvsp[-3].s));
	}
	if ((yyvsp[-2].s)) {
		(yyvsp[-2].s) = fix_filename ((yyvsp[-2].s));
		if (cb_flag_fold_copy_lower) {
			(yyvsp[-2].s) = fold_lower ((yyvsp[-2].s));
		} else if (cb_flag_fold_copy_upper) {
			(yyvsp[-2].s) = fold_upper ((yyvsp[-2].s));
		}
	}
	ppcopy ((yyvsp[-3].s), (yyvsp[-2].s), (yyvsp[0].r));
  ;}
    break;

  case 50:
#line 718 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	(yyval.s) = NULL;
  ;}
    break;

  case 51:
#line 722 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	(yyval.s) = (yyvsp[0].s);
  ;}
    break;

  case 52:
#line 726 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	(yyval.s) = (yyvsp[0].s);
  ;}
    break;

  case 55:
#line 737 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	(yyval.r) = NULL;
  ;}
    break;

  case 56:
#line 741 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	(yyval.r) = (yyvsp[0].r);
  ;}
    break;

  case 57:
#line 748 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	pp_set_replace_list ((yyvsp[0].r));
  ;}
    break;

  case 58:
#line 752 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	pp_set_replace_list (NULL);
  ;}
    break;

  case 59:
#line 759 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	(yyval.r) = cb_replace_list_add (NULL, (yyvsp[-2].l), (yyvsp[0].l), 0);
  ;}
    break;

  case 60:
#line 763 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	(yyval.r) = cb_replace_list_add (NULL, (yyvsp[-2].l), (yyvsp[0].l), CB_REPLACE_LEADING);
  ;}
    break;

  case 61:
#line 767 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	(yyval.r) = cb_replace_list_add (NULL, (yyvsp[-2].l), (yyvsp[0].l), CB_REPLACE_TRAILING);
  ;}
    break;

  case 62:
#line 771 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	(yyval.r) = cb_replace_list_add ((yyvsp[-3].r), (yyvsp[-2].l), (yyvsp[0].l), 0);
  ;}
    break;

  case 63:
#line 775 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	(yyval.r) = cb_replace_list_add ((yyvsp[-4].r), (yyvsp[-2].l), (yyvsp[0].l), CB_REPLACE_LEADING);
  ;}
    break;

  case 64:
#line 779 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	(yyval.r) = cb_replace_list_add ((yyvsp[-4].r), (yyvsp[-2].l), (yyvsp[0].l), CB_REPLACE_TRAILING);
  ;}
    break;

  case 65:
#line 786 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	(yyval.l) = (yyvsp[-1].l);
  ;}
    break;

  case 66:
#line 790 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	(yyval.l) = (yyvsp[0].l);
  ;}
    break;

  case 67:
#line 797 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	(yyval.l) = NULL;
  ;}
    break;

  case 68:
#line 801 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	(yyval.l) = (yyvsp[-1].l);
  ;}
    break;

  case 69:
#line 805 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	(yyval.l) = (yyvsp[0].l);
  ;}
    break;

  case 70:
#line 812 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	(yyval.l) = cb_text_list_add (NULL, (yyvsp[-1].s));
  ;}
    break;

  case 71:
#line 819 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	(yyval.l) = NULL;
  ;}
    break;

  case 72:
#line 823 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	(yyval.l) = cb_text_list_add (NULL, (yyvsp[-1].s));
  ;}
    break;

  case 73:
#line 830 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	(yyval.l) = cb_text_list_add (NULL, (yyvsp[0].s));
  ;}
    break;

  case 74:
#line 834 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	(yyval.l) = cb_text_list_add ((yyvsp[-1].l), (yyvsp[0].s));
  ;}
    break;

  case 75:
#line 841 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	(yyval.l) = cb_text_list_add (NULL, (yyvsp[0].s));
  ;}
    break;

  case 76:
#line 845 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	(yyval.l) = cb_text_list_add ((yyvsp[-2].l), " ");
	(yyval.l) = cb_text_list_add ((yyval.l), "IN");
	(yyval.l) = cb_text_list_add ((yyval.l), " ");
	(yyval.l) = cb_text_list_add ((yyval.l), (yyvsp[0].s));
  ;}
    break;

  case 77:
#line 852 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	(yyval.l) = cb_text_list_add ((yyvsp[-2].l), " ");
	(yyval.l) = cb_text_list_add ((yyval.l), "OF");
	(yyval.l) = cb_text_list_add ((yyval.l), " ");
	(yyval.l) = cb_text_list_add ((yyval.l), (yyvsp[0].s));
  ;}
    break;

  case 78:
#line 859 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	struct cb_text_list *l;

	(yyval.l) = cb_text_list_add ((yyvsp[-3].l), " ");
	(yyval.l) = cb_text_list_add ((yyval.l), "(");
	(yyvsp[-1].l) = cb_text_list_add ((yyvsp[-1].l), ")");
	for (l = (yyval.l); l->next; l = l->next) {
		;
	}
	l->next = (yyvsp[-1].l);
  ;}
    break;

  case 79:
#line 874 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	(yyval.l) = cb_text_list_add (NULL, (yyvsp[0].s));
  ;}
    break;

  case 80:
#line 878 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	(yyval.l) = cb_text_list_add ((yyvsp[-1].l), " ");
	(yyval.l) = cb_text_list_add ((yyval.l), (yyvsp[0].s));
  ;}
    break;

  case 81:
#line 888 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	(yyval.ui) = 0;
  ;}
    break;

  case 82:
#line 892 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	(yyval.ui) = 1;
  ;}
    break;

  case 83:
#line 899 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	(yyval.ui) = 0;
  ;}
    break;

  case 84:
#line 903 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"
    {
	(yyval.ui) = 1;
  ;}
    break;


      default: break;
    }

/* Line 1126 of yacc.c.  */
#line 2252 "ppparse.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  int yytype = YYTRANSLATE (yychar);
	  YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
	  YYSIZE_T yysize = yysize0;
	  YYSIZE_T yysize1;
	  int yysize_overflow = 0;
	  char *yymsg = 0;
#	  define YYERROR_VERBOSE_ARGS_MAXIMUM 5
	  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
	  int yyx;

#if 0
	  /* This is so xgettext sees the translatable formats that are
	     constructed on the fly.  */
	  YY_("syntax error, unexpected %s");
	  YY_("syntax error, unexpected %s, expecting %s");
	  YY_("syntax error, unexpected %s, expecting %s or %s");
	  YY_("syntax error, unexpected %s, expecting %s or %s or %s");
	  YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
#endif
	  char *yyfmt;
	  char const *yyf;
	  static char const yyunexpected[] = "syntax error, unexpected %s";
	  static char const yyexpecting[] = ", expecting %s";
	  static char const yyor[] = " or %s";
	  char yyformat[sizeof yyunexpected
			+ sizeof yyexpecting - 1
			+ ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
			   * (sizeof yyor - 1))];
	  char const *yyprefix = yyexpecting;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 1;

	  yyarg[0] = yytname[yytype];
	  yyfmt = yystpcpy (yyformat, yyunexpected);

	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
		  {
		    yycount = 1;
		    yysize = yysize0;
		    yyformat[sizeof yyunexpected - 1] = '\0';
		    break;
		  }
		yyarg[yycount++] = yytname[yyx];
		yysize1 = yysize + yytnamerr (0, yytname[yyx]);
		yysize_overflow |= yysize1 < yysize;
		yysize = yysize1;
		yyfmt = yystpcpy (yyfmt, yyprefix);
		yyprefix = yyor;
	      }

	  yyf = YY_(yyformat);
	  yysize1 = yysize + yystrlen (yyf);
	  yysize_overflow |= yysize1 < yysize;
	  yysize = yysize1;

	  if (!yysize_overflow && yysize <= YYSTACK_ALLOC_MAXIMUM)
	    yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg)
	    {
	      /* Avoid sprintf, as that infringes on the user's name space.
		 Don't have undefined behavior even if the translation
		 produced a string with the wrong number of "%s"s.  */
	      char *yyp = yymsg;
	      int yyi = 0;
	      while ((*yyp = *yyf))
		{
		  if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		    {
		      yyp += yytnamerr (yyp, yyarg[yyi++]);
		      yyf += 2;
		    }
		  else
		    {
		      yyp++;
		      yyf++;
		    }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    {
	      yyerror (YY_("syntax error"));
	      goto yyexhaustedlab;
	    }
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror (YY_("syntax error"));
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
        {
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
        }
      else
	{
	  yydestruct ("Error: discarding", yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (0)
     goto yyerrorlab;

yyvsp -= yylen;
  yyssp -= yylen;
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping", yystos[yystate], yyvsp);
      YYPOPSTACK;
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  *++yyvsp = yylval;


  /* Shift the error token. */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEOF && yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK;
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 915 "g:\\open-cobol_vs2008\\cobc\\ppparse.y"


