#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <errno.h>
#include <except.h>
#include <setjmp.h>
#include <mih/rslvsp.h>
#include <mipgexec.h>
#include <qmhchgem.h>
#include <qmhrcvpm.h>
#include <qmhsndpm.h>
#include <qusec.h>
#include <qleawi.h>

///////////////////////////////////////////////////////////////////////
// handler areas
typedef struct error_code_struct {
	Qus_EC_t	ec_fields;
	char		Exception_Data[100];
} error_code_struct;

// Type definition for message information structure used on the receive.
typedef struct msg_info_struct {
	Qmh_Rcvpm_RCVM0300_t	F;
	char					V[2200];
} msg_info_struct;

typedef struct hndl {
	_SYSPTR		ppgm;
	int			actmark;
} HANDLE;

static char dlerrorbuf[64];
const char * dlerror() {
	return dlerrorbuf;
}

void * dlopen(char * pg, int f) {
	_SYSPTR spgm = NULL; 
	int act;
	HANDLE * h;

#pragma exception_handler(Lnone, 0, _C1_ALL, _C2_ALL, _CTLA_HANDLE_NO_MSG)

	spgm = rslvsp (WLI_SRVPGM, pg, "", _AUTH_OBJ_MGMT);
	if(spgm == NULL) {
		return NULL;
	}
	act = QleActBndPgm (&spgm, NULL, NULL, NULL, NULL);
	h = (HANDLE *) malloc(sizeof(HANDLE));
	h->ppgm = spgm;
	h->actmark = act;
	return h;

Lnone:
#pragma disable_handler
	strcpy(dlerrorbuf, "Can't Activate Service Program");
	return NULL;
}

void * dlsym(HANDLE * H, char * name) {
	int id = 0;
	int type;
	void * proc;
	int len = (int) strlen(name);

#pragma exception_handler(Lnone, 0, _C1_ALL, _C2_ALL, _CTLA_HANDLE_NO_MSG)

	proc = QleGetExp (&H->actmark,  /* Service pgm activation mark  */
                      &id,          /* Export Id                    */
                      &len,         /* Export name length           */
                      name,         /* Export name                  */
                      NULL,         /* Pointer to Pointer to export */
                      &type,        /* type, see QLE_EX_* defn's    */
                      NULL);        /* Error code                   */
	if(type != 1) {
		strcpy(dlerrorbuf, "Name is not an Entry Point");
		return NULL;
	}
	return proc;

Lnone:
#pragma disable_handler
	strcpy(dlerrorbuf, "Entry Point Not Found");
	return NULL;
}

void dlclose(void * H) {
	free(H);
}
