@echo off
set COB_LIBRARY_PATH=.;%COB_LIBRARY_PATH%
echo FUNDAMENTAL TEST GROUP

echo DISPLAY literals
copy /y fundamental.1 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff fundamental.2 result
if errorlevel 1 goto err


echo DISPLAY literals, DECIMAL-POINT is COMMA
copy /y fundamental.3 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff fundamental.4 result
if errorlevel 1 goto err

echo Hexadecimal literal
copy /y fundamental.5 prog.cob > nul
copy /y fundamental.11 dump.c > nul
cl /LD dump.c > comp.out 2>&1
if errorlevel 1 goto err
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff fundamental.6 result
if errorlevel 1 goto err

echo DISPLAY data items with VALUE clause
copy /y fundamental.7 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff fundamental.8 result
if errorlevel 1 goto err

echo DISPLAY data items with MOVE statement
copy /y fundamental.9 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff fundamental.10 result
if errorlevel 1 goto err

echo MOVE to edited item (1)
copy /y fundamental.16 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff fundamental.17 result
if errorlevel 1 goto err

echo MOVE to edited item (2)
copy /y fundamental.18 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff fundamental.19 result
if errorlevel 1 goto err

echo MOVE to JUSTIFIED item
copy /y fundamental.20 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff fundamental.21 result
if errorlevel 1 goto err

echo MOVE integer literal to alphanumeric
copy /y fundamental.22 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > nul 2> comp.out
if errorlevel 1 goto err
diff fundamental.23 comp.out
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff fundamental.24 result
if errorlevel 1 goto err

echo GLOBAL at same level
copy /y fundamental.12 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff fundamental.13 result
if errorlevel 1 goto err

echo GLOBAL at lower level
copy /y fundamental.14 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff fundamental.15 result
if errorlevel 1 goto err

echo Contained program visibility (1)
copy /y fundamental.25 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result 2> comp.out
if not errorlevel 1 goto err
diff fundamental.26 comp.out
if errorlevel 1 goto err
diff fundamental.27 result
if errorlevel 1 goto err

echo Contained program visibility (2)
copy /y fundamental.28 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result 2> comp.out
if not errorlevel 1 goto err
diff fundamental.29 comp.out
if errorlevel 1 goto err
diff fundamental.30 result
if errorlevel 1 goto err

echo Contained program visibility (3)
copy /y fundamental.31 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff fundamental.32 result
if errorlevel 1 goto err

echo Contained program visibility (4)
copy /y fundamental.33 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff fundamental.34 result
if errorlevel 1 goto err

echo CANCEL test (1)
copy /y fundamental.35 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result 2> comp.out
if not errorlevel 1 goto err
diff fundamental.36 comp.out
if errorlevel 1 goto err
diff fundamental.37 result
if errorlevel 1 goto err

echo CANCEL test (2)
copy /y fundamental.38 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
copy /y fundamental.39 prog2.cob > nul
cobc -m -debug -Wall -std=cobol2002 prog2.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result 2> comp.out
if not errorlevel 1 goto err
diff fundamental.40 comp.out
if errorlevel 1 goto err
diff fundamental.37 result
if errorlevel 1 goto err

echo Separate sign positions (1)
copy /y fundamental.41 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff fundamental.42 result
if errorlevel 1 goto err

echo Separate sign positions (2)
copy /y fundamental.43 prog.cob > nul
cobc -x -debug -Wall -std=mf -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff fundamental.44 result
if errorlevel 1 goto err

echo Context sensitive words (1)
copy /y fundamental.45 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff fundamental.46 result
if errorlevel 1 goto err

echo Context sensitive words (2)
copy /y fundamental.47 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff fundamental.48 result
if errorlevel 1 goto err

echo Context sensitive words (3)
copy /y fundamental.49 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff fundamental.48 result
if errorlevel 1 goto err

echo Context sensitive words (4)
copy /y fundamental.50 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff fundamental.48 result
if errorlevel 1 goto err

echo Context sensitive words (5)
copy /y fundamental.51 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff fundamental.48 result
if errorlevel 1 goto err

echo Context sensitive words (6)
copy /y fundamental.52 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff fundamental.48 result
if errorlevel 1 goto err

echo Context sensitive words (7)
copy /y fundamental.53 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff fundamental.54 result
if errorlevel 1 goto err

echo ROUNDED AWAY-FROM-ZERO
copy /y fundamental.55 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff fundamental.56 result
if errorlevel 1 goto err

echo ROUNDED NEAREST-AWAY-FROM-ZERO
copy /y fundamental.57 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff fundamental.58 result
if errorlevel 1 goto err

echo ROUNDED NEAREST-EVEN
copy /y fundamental.59 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff fundamental.60 result
if errorlevel 1 goto err

echo ROUNDED NEAREST-TOWARD-ZERO
copy /y fundamental.61 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff fundamental.62 result
if errorlevel 1 goto err

echo ROUNDED TOWARD-GREATER
copy /y fundamental.63 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff fundamental.64 result
if errorlevel 1 goto err

echo ROUNDED TOWARD-LESSER
copy /y fundamental.65 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff fundamental.66 result
if errorlevel 1 goto err

echo ROUNDED TRUNCATION
copy /y fundamental.67 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff fundamental.68 result
if errorlevel 1 goto err

echo FUNDAMENTAL TEST PASSED
del test.conf dump.* prog.* prog2.* result comp.out
goto end

:err
	echo FUNDAMENTAL TEST FAILED
	pause
:end
